import controlP5.*;
ControlP5 controlP5;

//INTERACTIVE VISUALIZATION OF THE STATIC IMAGE
// Markus Selmke (selmke@rz.uni-leipzig.de, markus.selmke@gmx.de)

PImage im_0,im_10,im_20,im_30,im_40,im_50,im_60,im_70,im_80,im_90,im_100,im_110,im_120,im_130,im_140,im_150,im_160,im_170,im_180;
PImage im_P3d, im_P2d, im_Grad;

public int CSizex=750,CSizey=485; //canvas size
public float exponentV,delta,Exposure,A1,A2,A3,b,n0,ddelta,R,yRDn,theta,ev,dpsi,psiScale,YOffset,Scale,XOffset,LineLength,divergence,yLinScale;
public float sign,LengthE,Length0,nc,dndcol,ca,thetaPHmin,thetaPHmax,theta90PHmax,thetaL1,thetaL1max,thetaL1min,thetaL2min,thetaL2max,theta375,theta1;
float textX,textY,vx,vy,n,nRays,nRays1,nRays2,Nb,Nbs,bi,alphaV,Rm,Tm,cosi,cosr,dcol,sqrt3,tan31p,tan11p,cos11,cos31,cos41,tan41p,cos11p,cos31p;
float phiTIR, phi11, phi12, phi21, phi22, phi31, phi32, phi41, phi42, phi03, phiy3, phiz3;
float phi11p, phi12p, phi21p, phi22p, phi31p, phi32p, phi41p, phi42p, phi03p, phiy3p, phiz3p;
float f,x,y,xp,r11,r12,r31,r32,r41,r42;
int k,j,i,thetai,coli, nii,col;
float sinec, sinecp, evp;
public PFont font, CP5font;
public boolean ToggleI=true;

public float[] DeflectionAngles = new float[50];
public float[] GeometricFactors = new float[50];
public float[] FresnelFactors = new float[50];
public int[] ExitFace = new int[50];
public int[] Dispersed = new int[50];
public String[] TypeStr = new String[50];
public float[] Lengths = new float[50];
public float[] LeftRight = new float[50];
public float[][] RGBs = new float[3][50];

void setup(){
 size(CSizex,CSizey);
 background(0.1,0.1,0.1,1);
 smooth();
 
 ddelta = (PI/6)/99; //prism orientation increment
 
 n0 = 1.53;//1.331; //refarctive index
 dndcol = 0.01/3; //dispersion, i.e. n(col)=n0+dndcol*col, col=0,1,2,3,...
 Length0 = 4;
 sign = 1.0;
 exponentV = 0.5;
 
 ev =37.0; //light source elevation
 divergence = 0.0; //light source divergence
 delta = 0.0;
 ca = 1;
 
 YOffset = 230; //plot offset in y-direction
 XOffset = 250; //plot margin in x-direction
 Scale = 50; //plot scal
 psiScale = (CSizex-2*XOffset)/PI; //plot scale
 
 for (k=0; k<48; k++) {
  LeftRight[k] = 1.0; 
 }
 
 im_0 = loadImage("0.png");
 im_10 = loadImage("10.png");
 im_20 = loadImage("20.png");
 im_30 = loadImage("30.png");
 im_40 = loadImage("40.png");
 im_50 = loadImage("50.png");
 im_60 = loadImage("60.png");
 im_70 = loadImage("70.png");
 im_80 = loadImage("80.png");
 im_90 = loadImage("90.png");
 im_100 = loadImage("100.png");
 im_110 = loadImage("110.png");
 im_120 = loadImage("120.png");
 im_130 = loadImage("130.png");
 im_140 = loadImage("140.png");
 im_150 = loadImage("150.png");
 im_160 = loadImage("160.png");
 im_170 = loadImage("170.png");
 im_180 = loadImage("180.png");
 
 im_P2d = loadImage("Prism2d.png");
 im_P3d = loadImage("Prism3d.png");
 im_Grad = loadImage("GradientS.png");
 
 //initialize control sliders and checkboxes
 controlP5 = new ControlP5(this);
   font = createFont("Arial", 12); 
   textFont(font);
   ControlFont CP5font = new ControlFont(font); 
   controlP5.setControlFont(CP5font);
   
 Slider RefrIndex = controlP5.addSlider("refrindex", 1, 1.8, 1.53, CSizex - 200, 15, 100, 20);
   RefrIndex.captionLabel().toUpperCase(false);
   RefrIndex.setCaptionLabel("refractve index");
   RefrIndex.setValue(n0);
   
 Slider Elevation = controlP5.addSlider("elevation", 0, 50, 0.0, CSizex - 200, 40, 100, 20);
   Elevation.captionLabel().toUpperCase(false);
   Elevation.setCaptionLabel("elevation");
   Elevation.setValue(ev);
   
 Slider deltaslider = controlP5.addSlider("deltas", 0.01, 30, 0.0, CSizex - 200, 65, 100, 20);
   deltaslider.captionLabel().toUpperCase(false);
   deltaslider.setCaptionLabel("prism orientation");
   deltaslider.setValue(0.01);
   
 Slider visibilityslider = controlP5.addSlider("exponent", 0, 1, 0.0, CSizex - 200, 90, 100, 20);
   visibilityslider.captionLabel().toUpperCase(false);
   visibilityslider.setCaptionLabel("visibility");
   visibilityslider.setValue(exponentV);
}

void refrindex(float theValue) {
    n0 = theValue;
}
void elevation(float theValue) {
    ev = theValue*PI/180;
}
void deltas(float theValue) {
    delta = theValue*PI/180;
}
void exponent(float theValue) {
    exponentV = theValue;
}

void draw(){
  colorMode(RGB, 1,1,1,1);
  ellipseMode(CENTER);
  rectMode(CORNER);
  background(1,1,1,1);
  frame.setTitle("SIMULATE STATIC PRISM");
  
  noStroke(); fill(0.5,0.5,0.5,0.5);
  rect(CSizex - 205,10,200,105);
  
  image(im_P2d,CSizex-150,130);
  text("(c) denotes paths with net refraction. Columns appear with rainbow coloring.",10,10);
  text("paths without (c) may become bluish via total internal reflection.",10,20);
  text("annotation: Path type & azimuth [derees], coloring according to plots.",10,30);
  text("Markus Selmke",CSizex-90,CSizey-10);
  
  //refractive index for current color
        col = 0;
        nc = refractiveindex();
      //effective index of refraction including the effect of finite elevation  
        n = nc*sqrt(1-pow(sin(ev),2)/pow(nc,2))/sqrt(1-pow(sin(ev),2));  
        phiTIR = asin(1/n);
      //set though prism orientations
        theta = delta;
        
        //indicent angles on the three considered entry faces for the range of prism orientations
        //notation as in Reference: M. Denny, “Calculation of the 22◦ halo,” Eur. J. Phys. 18, 432–435 (1997).
        phi11 = PI/3 - theta;
        phi31 = theta;
        phi41 = PI/3 + theta;
        
        //refracted angles
        phi11p = asin(sin(phi11)/n);
        phi31p = asin(sin(phi31)/n);
        phi41p = asin(sin(phi41)/n);
        
        //internal angles for second interface (second to next to the entry face)
        phi12p = PI/3 - phi11p; 
        phi32p = PI/3 - phi31p;
        phi42p = PI/3 - phi41p;
        
        //refraced external angle
        phi12 = asin(n*sin(phi12p));
        phi32 = asin(n*sin(phi32p));
        phi42 = asin(n*sin(phi42p));
        
        //total deflection angles
        DeflectionAngles[0] = 0;
        DeflectionAngles[1] = phi12 - theta;
        DeflectionAngles[2] = PI/3 + 2*theta;
        DeflectionAngles[3] = phi32 + theta - PI/3;
        DeflectionAngles[4] = phi42 + theta;
        DeflectionAngles[5] = PI/3 + 2*theta;
        DeflectionAngles[6] = PI/3 - 2*theta;
        DeflectionAngles[7] = PI - 2*theta; 
        DeflectionAngles[8] = PI - 2*theta;
        DeflectionAngles[9] = theta + PI - phi42;
        DeflectionAngles[10] = theta -2*PI/3 - phi32;
        DeflectionAngles[11] = PI + 2*theta;
        DeflectionAngles[12] = PI/3 - 2*theta;
        DeflectionAngles[13] = PI + 2*theta; //PI + 2*theta;
        DeflectionAngles[14] = 5*PI/3 - 2*theta;
        DeflectionAngles[15] = 2*theta - PI;
        DeflectionAngles[16] = 7*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[17] = 5*PI/3 + 2*theta;
        DeflectionAngles[18] = PI/3 + 2*theta;
        DeflectionAngles[19] = PI - theta - phi12;
        DeflectionAngles[20] = 4*PI/3 - theta + phi12;
        DeflectionAngles[21] = 4*PI/3 + theta + phi42;
        DeflectionAngles[22] = PI + theta + phi32;
        DeflectionAngles[23] = 9*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[24] = 11*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[25] = 13*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[26] = 2*PI/3 + theta + phi42;
        DeflectionAngles[27] = 2*PI/3 - theta + phi12;
        DeflectionAngles[28] = -PI/3 - theta - phi12;
        DeflectionAngles[29] = 15*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[30] = 17*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[31] = 19*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[32] = 21*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[33] = 23*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[34] = 25*PI/3 + 2*theta - 8*PI;
        DeflectionAngles[35] = 4*PI/3;
        DeflectionAngles[36] = 4*PI/3;
        DeflectionAngles[37] = 4*PI/3;
        DeflectionAngles[38] = 5*PI/3 + 2*theta;
        DeflectionAngles[39] = 5*PI/3 + 2*theta;
        DeflectionAngles[40] = 2*PI/3 - theta + phi12;
        DeflectionAngles[41] = 2*PI/3 + theta + phi42;
        DeflectionAngles[42] = PI/3 + theta + phi32;
        DeflectionAngles[43] = 4*PI/3;
        DeflectionAngles[44] = 4*PI/3;
        DeflectionAngles[45] = 4*PI/3;
        DeflectionAngles[46] = 4*PI/3;
        DeflectionAngles[47] = PI/3 + 2*theta; //132, A1
        DeflectionAngles[48] = PI - 2*theta; //132, A2
        DeflectionAngles[49] = PI/3 - 2*theta; //132, A3
      
        //Reflect angles
          //DeflectionAngleReflection();
        
        //appearing constants
          sqrt3 = sqrt(3); 
          tan31p=tan(phi31p); tan11p=tan(phi11p); tan41p=tan(phi41p);
          cos11=cos(phi11); cos31=cos(phi31); cos41=cos(phi41);
          cos11p=cos(phi11p); cos31p=cos(phi31p);
        
        //geometrical contrains. A single number for each Ray path according to the supplemented map
          f=(1-sqrt3*tan31p)/2;
        GeometricFactors[0]=max(0,f);
          x=(-1+sqrt3*tan11p)/2; x=max(0,x);
          y=1-sqrt3*tan11p; y=max(0,y);
          f=1-x-y; f=min(1,f);
        GeometricFactors[1]=f/2;
        GeometricFactors[2]=1.0/2;
          f=sqrt3*tan31p/2;
        GeometricFactors[3]=max(0,f);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          f=1-x; f=f/2;
        GeometricFactors[4]=max(0,f);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          f=x/2;
        GeometricFactors[5]=max(0,f);
        GeometricFactors[6]=1.0/2;
          x=(3.0/2)*(-1+sqrt3*tan11p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan11p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f/2;
        GeometricFactors[7]=max(0,f);
        GeometricFactors[8]=1.0/2;
          //x=-1+sin(PI/6+phi41p)/cos(phi41p); x=max(0,x);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          y=(5-3*sqrt3*tan41p)/2; y=max(0,y);
          f=1-x-y; f=min(1,f); f=f/2;
        GeometricFactors[9]=f;
          x=1-sqrt3*tan11p; x=max(0,x);
        GeometricFactors[10]=x/2;
          x=(3.0/2)*(-1+sqrt3*tan41p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan41p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f/2;
        GeometricFactors[11]=max(0,f);
          x=(sqrt3*tan11p-1)/2;
          f=x/2;
        GeometricFactors[12]=max(0,f);
          x=(-1+3*sqrt3*tan31p)/2; x=max(0,x);
          y=(-1+5*sqrt3*tan31p)/2; y=max(0,y);
          xp=sqrt3*tan31p; y=min(y,xp); y=min(1,y);
          f=y-x; f=max(0,f); 
        GeometricFactors[13]=f/2;
          x=(-1+3*sqrt3*tan11p)/2; x=max(0,x);
          y=(-1+5*sqrt3*tan11p)/2; y=max(0,y);
          xp=sqrt3*tan11p; y=min(y,xp); y=min(1,y);
          f=y-x; f=max(0,f);
        GeometricFactors[14]=f/2;;
          f=(1-2*sqrt3*tan31p)/2; 
        GeometricFactors[15]=max(0,f);
          x=sqrt3*tan31p;
          xp=(-1+9*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+7*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f);
        GeometricFactors[16]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+7*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+5*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(f,0);
        GeometricFactors[17]=f/2;
          x=(3.0/2)*(-1+sqrt3*tan31p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan31p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f/2;
        GeometricFactors[18]=max(0,f);  
          x=(-1+sqrt3*tan11p)/2; x=max(0,x); x=min(1,x);
          y=(5-3*sqrt3*tan11p)/2; y=max(0,y); y=min(1,y);
          f=1-x-y;
        GeometricFactors[19]=f/2;
          x=2.0*(-1+sqrt3*tan11p); x=max(0,x);
          y=-(3.0/2)*(-1+sqrt3*tan11p); y=max(0,y);
          f=1-x-y; f=f/2;
        GeometricFactors[20]=max(0,f);
          x=2.0*(-1+sqrt3*tan41p); x=max(0,x);
          y=-(3.0/2)*(-1+sqrt3*tan41p); y=max(0,y);
          f=1-x-y; f=f/2;
        GeometricFactors[21]=max(0,f); 
          x=2.0*(-1+sqrt3*tan31p); x=max(0,x);
          y=-(3.0/2)*(-1+sqrt3*tan31p); y=max(0,y);
          f=1-x-y; f=f/2;
        GeometricFactors[22]=max(0,f);
          x=sqrt3*tan31p;
          xp=(-1+11*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+9*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[23]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+13*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+11*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[24]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+15*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+13*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[25]=f/2;
          xp=(-1+sqrt3*tan41p)/2; xp=max(0,xp); xp=min(1,xp);
          x=(-2+sqrt(3)*tan41p); x=max(0,x); x=min(1,x);
          f=xp-x; f=f/2;
        GeometricFactors[26]=max(0,f);
          xp=(-1+sqrt3*tan11p)/2; xp=max(0,xp); xp=min(1,xp);
          x=(-2+sqrt(3)*tan11p); x=max(0,x); x=min(1,x);
          f=xp-x; f=f/2;
        GeometricFactors[27]=max(0,f);
          x=1-sqrt3*tan11p; x=max(0,x);
          f=x/2;
        GeometricFactors[28]=max(0,f);  
          x=sqrt3*tan31p;
          xp=(-1+17*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+15*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[29]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+19*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+17*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[30]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+21*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+19*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[31]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+23*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+21*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[32]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+25*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+23*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[33]=f/2;
          x=sqrt3*tan31p;
          xp=(-1+27*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+25*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[34]=f/2;
          x=(3.0/2)*(1-sqrt3*tan11p); x=min(1,x); x=max(0,x);
          y=(5.0/2)*(1-sqrt3*tan11p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[35]=f/2;  
          x=(3.0/2)*(1-sqrt3*tan31p); x=min(1,x); x=max(0,x);
          y=(5.0/2)*(1-sqrt3*tan31p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[36]=f/2;
          x=(3.0/2)*(1-sqrt3*tan41p); x=min(1,x); x=max(0,x);
          y=(5.0/2)*(1-sqrt3*tan41p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[37]=f/2;
        GeometricFactors[38]=GeometricFactors[27];
        GeometricFactors[39]=GeometricFactors[26];
          x=1-sqrt3*tan11p; x=max(0,x);
          xp=1-2*sqrt3*tan11p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0/2)*(1-sqrt3*tan11p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[40]=f/2.0;
          x=1-sqrt3*tan41p; x=max(0,x);
          xp=1-2*sqrt3*tan41p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0/2)*(1-sqrt3*tan41p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[41]=f/2.0;
          x=1-sqrt3*tan31p; x=max(0,x);
          xp=1-2*sqrt3*tan31p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0/2)*(1-sqrt3*tan31p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[42]=f/2.0;
          x=1-sqrt3*tan11p; x=max(0,x);
          y=(3-5*sqrt3*tan11p)/2; y=max(0,y);
          f=x-y; f=max(0,f); f=min(1,f);
        GeometricFactors[43]=f/2.0;
          x=1-sqrt3*tan31p; x=max(0,x);
          y=(3-5*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); f=min(1,f);
        GeometricFactors[44]=f/2.0;
        GeometricFactors[45]=GeometricFactors[17];
        GeometricFactors[46]=GeometricFactors[16];
        
      //convert projected 2D in-plane to incidence plane angles for correct Fresnel coefs.
      if (ToggleI==true) {
        sinec = sin(PI/2-ev); //ev is the external elevation angle (e.g. solar elevation)
        evp = asin(sin(ev)/nc); //evp is the internal elevation angle
        sinecp = sin(PI/2-evp);
        phi11p = acos(cos(phi11p)*sinecp); phi11 = acos(cos11*sinec);
        phi31p = acos(cos(phi31p)*sinecp); phi31 = acos(cos31*sinec);
        phi41p = acos(cos(phi41p)*sinecp); phi41 = acos(cos41*sinec);
      };  
        
      //Fresnel Coefs:
        r11=(pow(sin(phi11-phi11p),2)/pow(sin(phi11+phi11p),2) + pow(tan(phi11-phi11p),2)/pow(tan(phi11+phi11p),2))/2;
        r31=(pow(abs(sin(phi31-phi31p)),2)/pow(abs(sin(phi31+phi31p)),2) + pow(abs(tan(phi31-phi31p)),2)/pow(abs(tan(phi31+phi31p)),2))/2;
        //r31=abs(1/sin(phi31+phi31p));// + pow(tan(phi31-phi31p),2)/pow(tan(phi31+phi31p),2))/2;
        r41=(pow(sin(phi41-phi41p),2)/pow(sin(phi41+phi41p),2) + pow(tan(phi41-phi41p),2)/pow(tan(phi41+phi41p),2))/2;
        //check for NaN:
        if(r31 != r31) {
          r31=0;
        }
      //check for total internal reflection
        if (phi32p>phiTIR) {
          r32 = 1;
        } else {
          r32=(pow(sin(phi32-phi32p),2)/pow(sin(phi32+phi32p),2) + pow(tan(phi32-phi32p),2)/pow(tan(phi32+phi32p),2))/2;
        }
        if (phi12p>phiTIR) {
          r12 = 1;
        } else {
          r12=(pow(sin(phi12-phi12p),2)/pow(sin(phi12+phi12p),2) + pow(tan(phi12-phi12p),2)/pow(tan(phi12+phi12p),2))/2; 
        }
        if (phi42p>phiTIR) {
          r42 = 1;
        } else {
          r42=(pow(sin(phi42-phi42p),2)/pow(sin(phi42+phi42p),2) + pow(tan(phi42-phi42p),2)/pow(tan(phi42+phi42p),2))/2; 
        }
      //Fresnel factors for each ray, i.e. product of Fresnel coefs for each face encountered 
        FresnelFactors[0]=pow(1-r31,2);
        FresnelFactors[1]=(1-r11)*(1-r12);
        FresnelFactors[2]=r11;
        FresnelFactors[3]=(1-r31)*(1-r32);
        FresnelFactors[4]=(1-r41)*(1-r42);
        FresnelFactors[5]=pow(1-r41,2);
        FresnelFactors[6]=r41;
        FresnelFactors[7]=pow(1-r11,2)*r12;
        FresnelFactors[8]=r31;
        FresnelFactors[9]=(1-r41)*r42*(1-r42);
        FresnelFactors[10]=(1-r31)*r31*(1-r32);
        FresnelFactors[11]=pow(1-r41,2)*r42;
        FresnelFactors[12]=pow(1-r11,2);
        FresnelFactors[13]=pow(1-r31,2)*pow(r32,2)*1;
        FresnelFactors[14]=pow(1-r11,2)*pow(r12,2)*1;
        FresnelFactors[15]=pow(1-r31,2)*r31;
        FresnelFactors[16]=(1-r31)*r32*1*(1-r31);
        FresnelFactors[17]=(1-r31)*r32*1*(1-r31);// FresnelFactors[17]=1;
        FresnelFactors[18]=pow(1-r31,2)*r32;  
        FresnelFactors[19]=(1-r11)*r12*(1-r12);
        FresnelFactors[20]=(1-r11)*r12*r11*(1-r12);
        FresnelFactors[21]=(1-r41)*r42*r41*(1-r42);
        FresnelFactors[22]=(1-r31)*r32*r31*(1-r32);
        FresnelFactors[23]=FresnelFactors[16]; 
        FresnelFactors[24]=FresnelFactors[16]; 
        FresnelFactors[25]=FresnelFactors[16]; 
        FresnelFactors[29]=FresnelFactors[16];
        FresnelFactors[30]=FresnelFactors[16];
        FresnelFactors[31]=FresnelFactors[16];
        FresnelFactors[32]=FresnelFactors[16];
        FresnelFactors[33]=FresnelFactors[16];
        FresnelFactors[34]=FresnelFactors[16];
        FresnelFactors[26]=(1-r41)*r41*(1-r42);
        FresnelFactors[27]=(1-r11)*r11*(1-r12);
        FresnelFactors[28]=(1-r11)*r11*(1-r12);
        FresnelFactors[35]=(1-r11)*r12*r11*(1-r11);
        FresnelFactors[36]=(1-r31)*r32*r31*(1-r31);
        FresnelFactors[37]=(1-r41)*r42*r41*(1-r41);
        FresnelFactors[38]=(1-r11)*r11*r12*(1-r11);
        FresnelFactors[39]=(1-r41)*r41*r42*(1-r41);
        FresnelFactors[40]=(1-r11)*r12*1*(1-r12);
        FresnelFactors[41]=(1-r41)*r42*1*(1-r42);
        FresnelFactors[42]=(1-r31)*r32*1*(1-r32);
        FresnelFactors[43]=(1-r11)*r11*r12*(1-r11);
        FresnelFactors[44]=(1-r31)*r31*r32*(1-r31);
        FresnelFactors[45]=(1-r31)*r32*1*r31*(1-r31);
        FresnelFactors[46]=(1-r31)*r32*1*r31*(1-r31);
  
        LengthE = cos(ev)*Length0;
        ExitFace[0]=5; Lengths[0]=LengthE; TypeStr[0]="T"; Dispersed[0] = 0;
        ExitFace[1]=5; Lengths[1]=0.9*LengthE; TypeStr[1]="37"; RGBs[0][1] = 1; RGBs[1][1] = 0; RGBs[2][1] = 0; LeftRight[1] = -1.0; Dispersed[1] = 1;
        ExitFace[2]=3; Lengths[2]=LengthE; TypeStr[2]="3"; Dispersed[2] = 0;
        ExitFace[3]=6; Lengths[3]=0.9*LengthE; TypeStr[3]="37"; RGBs[0][3] = 1; RGBs[1][3] = 0; RGBs[2][3] = 0; Dispersed[3] = 1;
        ExitFace[4]=5; Lengths[4]=0.9*LengthE; TypeStr[4]="37"; RGBs[0][4] = 1; RGBs[1][4] = 0; RGBs[2][4] = 0; Dispersed[4] = 1;
        ExitFace[5]=5; Lengths[5]=0.95*LengthE; TypeStr[5]="387"; RGBs[0][5] = 1; RGBs[1][5] = 0.5; RGBs[2][5] = 0; Dispersed[5] = 0;
        ExitFace[6]=7; Lengths[6]=LengthE; TypeStr[6]="3"; LeftRight[6] = -1.0; Dispersed[6] = 0;
        ExitFace[7]=7; Lengths[7]=0.6*LengthE; TypeStr[7]="375"; RGBs[0][7] = 0.18; RGBs[1][7] = 0.87; RGBs[2][7] = 0.78; LeftRight[7] = -1.0; Dispersed[7] = 0;
        ExitFace[8]=8; Lengths[8]=LengthE; TypeStr[8]="3"; LeftRight[8] = -1.0; Dispersed[8] = 0;
        ExitFace[9]=8; Lengths[9]=0.6*LengthE; TypeStr[9]="374"; RGBs[0][9] = 0; RGBs[1][9] = 0.5; RGBs[2][9] = 0; LeftRight[9] = 1.0; Dispersed[9] = 1;
        ExitFace[10]=7; Lengths[10]=0.6*LengthE; TypeStr[10]="364"; RGBs[0][10] = 0; RGBs[1][10] = 0.3; RGBs[2][10] = 0; Dispersed[10] = 1;
        ExitFace[11]=3; Lengths[11]=0.6*LengthE; TypeStr[11]="375"; RGBs[0][11] = 0.18; RGBs[1][11] = 0.87; RGBs[2][11] = 0.78; LeftRight[11] = 1.0; Dispersed[11] = 0;
        ExitFace[12]=5; Lengths[12]=0.95*LengthE; TypeStr[12]="387"; RGBs[0][12] = 1; RGBs[1][12] = 0.5; RGBs[2][12] = 0; LeftRight[12] = -1.0; Dispersed[12] = 0;
        ExitFace[13]=8; Lengths[13]=0.6*LengthE; TypeStr[13]="35673"; RGBs[0][13] = 0.14; RGBs[1][13] = 0.62; RGBs[2][13] = 0.86; Dispersed[13] = 0; LeftRight[13] = 1.0;
        ExitFace[14]=3; Lengths[14]=0.6*LengthE; TypeStr[14]="35673"; RGBs[0][14] = 0.14; RGBs[1][14] = 0.62; RGBs[2][14] = 0.86; Dispersed[14] = 0; LeftRight[14] = -1.0;
        ExitFace[15]=8; Lengths[15]=0.7*LengthE; TypeStr[15]="363"; Dispersed[15] = 0; LeftRight[15] = 1.0;
        ExitFace[16]=4; Lengths[16]=0.5*LengthE; TypeStr[16]="RT3"; RGBs[0][16] = 0.21; RGBs[1][16] = 0.77; RGBs[2][16] = 0.97; Dispersed[16] = 0;
        ExitFace[17]=6; Lengths[17]=0.55*LengthE; TypeStr[17]="RT2"; RGBs[0][17] = 0.21; RGBs[1][17] = 0.77; RGBs[2][17] = 0.97; LeftRight[17] = 1.0; Dispersed[17] = 0;
        ExitFace[18]=4; Lengths[18]=0.6*LengthE; TypeStr[18]="375"; RGBs[0][18] = 0.18; RGBs[1][18] = 0.87; RGBs[2][18] = 0.78; Dispersed[18] = 0;
        ExitFace[19]=8; Lengths[19]=0.6*LengthE; TypeStr[19]="374"; RGBs[0][19] = 0; RGBs[1][19] = 0.5; RGBs[2][19] = 0; LeftRight[19] = -1.0; Dispersed[19] = 1;
        ExitFace[20]=3; Lengths[20]=0.6*LengthE; TypeStr[20]="3573"; RGBs[0][20] = 1; RGBs[1][20] = 0; RGBs[2][20] = 0.5; LeftRight[20] = -1.0; Dispersed[20] = 1;
        ExitFace[21]=7; Lengths[21]=0.6*LengthE; TypeStr[21]="3573"; RGBs[0][21] = 1; RGBs[1][21] = 0; RGBs[2][21] = 0.5; LeftRight[21] = 1.0; Dispersed[21] = 1;
        ExitFace[22]=8; Lengths[22]=0.6*LengthE; TypeStr[22]="3573"; RGBs[0][22] = 1; RGBs[1][22] = 0; RGBs[2][22] = 0.5; LeftRight[22] = 1.0; Dispersed[22] = 1;
        ExitFace[23]=8; Lengths[23]=0.45*LengthE; TypeStr[23]="RT4"; RGBs[0][23] = 0.21; RGBs[1][23] = 0.77; RGBs[2][23] = 0.97; LeftRight[23] = 1.0; Dispersed[23] = 0;
        ExitFace[24]=6; Lengths[24]=0.40*LengthE; TypeStr[24]="RT5"; RGBs[0][24] = 0.21; RGBs[1][24] = 0.77; RGBs[2][24] = 0.97; LeftRight[24] = 1.0; Dispersed[24] = 0;
        ExitFace[25]=4; Lengths[25]=0.35*LengthE; TypeStr[25]="RT6"; RGBs[0][25] = 0.21; RGBs[1][25] = 0.77; RGBs[2][25] = 0.97; Dispersed[25] = 0; LeftRight[25] = 1.0;
        ExitFace[26]=3; Lengths[26]=0.6*LengthE; TypeStr[26]="3875"; RGBs[0][26] = 0.95; RGBs[1][26] = 0.86; RGBs[2][26] = 0.26; Dispersed[26] = 1;
        ExitFace[27]=7; Lengths[27]=0.6*LengthE; TypeStr[27]="3875"; RGBs[0][27] = 0.95; RGBs[1][27] = 0.86; RGBs[2][27] = 0.26; LeftRight[27] = -1.0; Dispersed[27] = 1;
        ExitFace[28]=4; Lengths[28]=0.6*LengthE; TypeStr[28]="364"; RGBs[0][28] = 0; RGBs[1][28] = 0.5; RGBs[2][28] = 0; LeftRight[28] = -1.0; Dispersed[28] = 1;
        ExitFace[29]=8; Lengths[29]=0.3*LengthE; TypeStr[29]="RT7"; RGBs[0][29] = 0.21; RGBs[1][29] = 0.77; RGBs[2][29] = 0.97; Dispersed[29] = 0; LeftRight[29] = 1.0;
        ExitFace[30]=6; Lengths[30]=0.25*LengthE; TypeStr[30]="RT8"; RGBs[0][30] = 0.21; RGBs[1][30] = 0.77; RGBs[2][30] = 0.97; LeftRight[30] = 1.0; Dispersed[30] = 0;
        ExitFace[31]=4; Lengths[31]=0.2*LengthE; TypeStr[31]="RT9"; RGBs[0][31] = 0.21; RGBs[1][31] = 0.77; RGBs[2][31] = 0.97; Dispersed[31] = 0;
        ExitFace[32]=8; Lengths[32]=0.15*LengthE; TypeStr[32]="RT10"; RGBs[0][32] = 0.21; RGBs[1][32] = 0.77; RGBs[2][32] = 0.97; Dispersed[32] = 0;
        ExitFace[33]=6; Lengths[33]=0.1*LengthE; TypeStr[33]="RT11"; RGBs[0][33] = 0.21; RGBs[1][33] = 0.77; RGBs[2][33] = 0.97; LeftRight[33] = 1.0; Dispersed[33] = 0;
        ExitFace[34]=4; Lengths[34]=0.05*LengthE; TypeStr[34]="RT12"; RGBs[0][34] = 0.21; RGBs[1][34] = 0.77; RGBs[2][34] = 0.97; Dispersed[34] = 0;
        ExitFace[35]=4; Lengths[35]=0.6*LengthE; TypeStr[35]="3574"; Dispersed[35] = 0; LeftRight[35] = -1.0;
        ExitFace[36]=7; Lengths[36]=0.6*LengthE; TypeStr[36]="3574"; LeftRight[36] = 1.0; Dispersed[36] = 0;
        ExitFace[37]=6; Lengths[37]=0.6*LengthE; TypeStr[37]="3574"; LeftRight[37] = -1.0; Dispersed[37] = 0;
        ExitFace[38]=3; Lengths[38]=0.4*LengthE; TypeStr[38]="38753"; LeftRight[38] = -1.0; Dispersed[38] = 0;
        ExitFace[39]=7; Lengths[39]=0.4*LengthE; TypeStr[39]="38753"; LeftRight[39] = 1.0; Dispersed[39] = 0; RGBs[0][39] = 1.0;
        ExitFace[40]=7; Lengths[40]=0.6*LengthE; TypeStr[40]="3567"; RGBs[0][40] = 0.95; RGBs[1][40] = 0.86; RGBs[2][40] = 0.26; LeftRight[40] = -1.0; Dispersed[40] = 1;
        ExitFace[41]=3; Lengths[41]=0.6*LengthE; TypeStr[41]="3567"; RGBs[0][41] = 0.95; RGBs[1][41] = 0.86; RGBs[2][41] = 0.26; Dispersed[41] = 1;
        ExitFace[42]=4; Lengths[42]=0.6*LengthE; TypeStr[42]="3567"; RGBs[0][42] = 0.95; RGBs[1][42] = 0.86; RGBs[2][42] = 0.26; Dispersed[42] = 1;
        ExitFace[43]=8; Lengths[43]=0.6*LengthE; TypeStr[43]="3684"; Dispersed[43] = 0;
        ExitFace[44]=3; Lengths[44]=0.6*LengthE; TypeStr[44]="3684"; Dispersed[44] = 0; LeftRight[44] = -1.0;
        ExitFace[45]=3; Lengths[45]=0.3*LengthE; TypeStr[45]="RT2r"; Dispersed[45] = 0; LeftRight[45] = -1.0;
        ExitFace[46]=7; Lengths[46]=0.3*LengthE; TypeStr[46]="RT3r"; Dispersed[46] = 0; LeftRight[46] = 1.0;
        
        DrawColumns();
        //fill(0,0,0,1);
        //text(str(FresnelFactors[38]),10,10); text(str(GeometricFactors[38]),150,10);
        //text(str(FresnelFactors[39]),10,30); text(str(GeometricFactors[39]),150,30);
        
        if (ToggleI==false) {
          fill(0,0,0,1); text("no incidence plane correction for Fresnel coefs.",150,60);
        };
}

//refractive index with dispersion
float refractiveindex() {
  return n0 + dndcol*col;
}

float signum(float f) {
  if (f > 0) return 1.0;
  if (f < 0) return -1.0;
  return 0;
}

// return a random value in the range [-1..1] with normal distribution around 0.
// Implements the Marsaglia Polar Method, as described in wikipedia, but only returns one of the values.
float randomNormal() {
  float x = 1.0, y = 1.0, s = 2.0; // s = x^2 + y^2
  while(s >= 1.0) {
    x = random(-1.0f, 1.0f);
    y = random(-1.0f, 1.0f);
    s = x*x + y*y;
  }
  return x * sqrt(-2.0f * log(s)/s);
}

float Px(int nii, float delta) {
  return -sin(delta - (nii-2)*PI/3);
}
float Py(int nii, float delta) {
  return cos(delta - (nii-2)*PI/3);
}

float DeflectionAngleReflection(float Angle) {
  Angle = abs(Angle);
  if (Angle >= PI) {
    Angle = 2*PI - Angle;
  }
  return Angle;
}

void DrawColumns() {
  //DRAW SHADOW
  beginShape();
  stroke(0,0,1,0); fill(0.5,0.5,0.5,0.2);
      vertex(XOffset+Scale*Px(5,delta),YOffset+Scale*Py(5,delta));
      vertex(XOffset+Scale*Px(4,delta),YOffset+Scale*Py(4,delta));
      vertex(XOffset+Scale*Px(3,delta),YOffset+Scale*Py(3,delta));
      vertex(XOffset+Scale*Px(2,delta),YOffset+Scale*Py(2,delta));
      vertex(XOffset+Scale*(Px(2,delta)+LengthE),YOffset+Scale*Py(2,delta));
      vertex(XOffset+Scale*(Px(3,delta)+LengthE),YOffset+Scale*Py(3,delta));
      vertex(XOffset+Scale*(Px(4,delta)+LengthE),YOffset+Scale*Py(4,delta));
      vertex(XOffset+Scale*(Px(5,delta)+LengthE),YOffset+Scale*Py(5,delta));
  endShape();
  text("shadow",XOffset+15+Scale*(Px(5,delta)+LengthE),YOffset+10+Scale*Py(5,delta));
  
  //DRAW HEXAGON
  stroke(0,0,0,0.5); //line(0,YOffset,200,YOffset);
  beginShape();
  stroke(0,0,0,1); fill(0,0.5,1,0.5); strokeWeight(1);
  for (nii=1; nii<=7; nii++) {
      vertex(XOffset+Scale*Px(nii,delta),YOffset+Scale*Py(nii,delta));
      //text(str(nii),XOffset+Scale*Px(nii,delta),YOffset+Scale*Py(nii,delta));
  }
  endShape();
  
  for (k=1; k<47; k++) {
    nii = ExitFace[k]-2; //faces now [1,..,6]
    vx = 2*(Px(nii+1,delta)-Px(nii,delta))/sqrt(pow(Px(nii+1,delta)-Px(nii,delta),2)+pow(Py(nii+1,delta)-Py(nii,delta),2));
    vy = 2*(Py(nii+1,delta)-Py(nii,delta))/sqrt(pow(Px(nii+1,delta)-Px(nii,delta),2)+pow(Py(nii+1,delta)-Py(nii,delta),2));
    beginShape();
    stroke(0,0,1,0); fill(RGBs[0][k],RGBs[1][k],RGBs[2][k],pow(0.9*FresnelFactors[k],exponentV)); //strokeWeight(3);
      vertex(XOffset+Scale*Px(nii,delta),YOffset+Scale*Py(nii,delta));
      vertex(XOffset+Scale*(Px(nii,delta)+vx*GeometricFactors[k]),YOffset+Scale*(Py(nii,delta)+vy*GeometricFactors[k]));
      vertex(XOffset+Scale*(Px(nii,delta)+vx*GeometricFactors[k]+Lengths[k]*cos(DeflectionAngles[k])),YOffset+Scale*(Py(nii,delta)+vy*GeometricFactors[k]+Lengths[k]*LeftRight[k]*sin(DeflectionAngles[k])));
      vertex(XOffset+Scale*(Px(nii,delta)+Lengths[k]*cos(DeflectionAngles[k])),YOffset+Scale*(Py(nii,delta)+Lengths[k]*LeftRight[k]*sin(DeflectionAngles[k])));
    endShape();
    //ANNOTATE
    if (GeometricFactors[k]*FresnelFactors[k] > 0) {
      textX = XOffset+Scale*(Px(nii,delta)+vx*GeometricFactors[k]+Lengths[k]*cos(DeflectionAngles[k]));
      textY = YOffset+Scale*(Py(nii,delta)+vy*GeometricFactors[k]+Lengths[k]*LeftRight[k]*sin(DeflectionAngles[k]));
      if (Dispersed[k] == 1) {
          TypeStr[k] = TypeStr[k] + "(c)"; //indicate that the column shows net refracation
      }
      fill(RGBs[0][k],RGBs[1][k],RGBs[2][k],1);
        text(TypeStr[k],textX,textY+10);
      //fill(RGBs[0][k],RGBs[1][k],RGBs[2][k],0.3);
        //text(str(k),textX,textY);
      fill(RGBs[0][k],RGBs[1][k],RGBs[2][k],0.5);
        text(nf(abs(DeflectionAngleReflection(DeflectionAngles[k]))*180/PI,0,1),textX,textY+20);
    }
    
  }
}

//Key press events
void keyPressed() {
  if (key == 'i') {
      ToggleI = !ToggleI; //pressing space bar
  }
}
